import path, { dirname } from 'path';
import { fileURLToPath } from 'url';

const __filename = fileURLToPath(import.meta.url);
const __dirname = dirname(__filename);
export const directoryPath = path.resolve(__dirname);

export const defaultImportModules = [
  {
    name: 'sequelize',
    version: '^6.6.5',
  },
  {
    name: 'pg',
    version: '^8.12.1',
  },
];

export const dynamicImport = async (name: string) => {
  // const nodeModules = path.resolve(directoryPath, 'node_modules');
  // const nodeName = path.resolve(nodeModules, name);
  console.log(`Dynamic import module ${name}`);
  try {
    return await import(name);
    // const require = getRequire();
    // const nodeCache = require.cache[require.resolve(name)];
    // if (nodeCache) {
    //   console.log(`${name} is cached`);
    // }
    // return require(name);
  } catch (e) {
    console.error(`Failed to import module ${name}: ${e.message}`);
    throw `Failed to import module ${name}: ${e.message}`;
  }
};
